import "Turbine";
import "Turbine.UI";
-- import "Turbine.UI.Extensions";
import "Turbine.UI.Lotro";
-- import "Turbine.Utils";
import "Turbine.Gameplay";
-- import "Turbine.Debug";
import "Turbine.Utils.Class";
import "Alexey.DebugFunc";

FilterBagWindow = class( Turbine.UI.Lotro.Window );

debugging = false;

--OldSearchText = "wazoooo"; -- will use eventually, not right now though.
savedItemList = {}
player = {};
verinfo = Turbine.PluginData.Load(Turbine.DataScope.Server, "version");

function echo(yayoutput)
  if debugging then
    Turbine.Shell.WriteLine(yayoutput);
  end
end

function echoTable(t)
  if not debugging then return; end
  if not t then
	Turbine.Shell.WriteLine("null");
  elseif type(t) == "table" then
	Turbine.Shell.WriteLine(t[1] .. " " .. t[2]);
  else
	Turbine.Shell.WriteLine(t);
  end
end

Version = "";
function VerCheck()
--  return verinfo and verinfo.version and string.find(verinfo.version, "03.02.05")
  local character = pcall( Turbine.Gameplay.LocalPlayer.GetInstance )
  if character then Version = "03.02.05"; end
return character;
end

function MyGetPlayer()
-- for k,v in pairs(verinfo) do Turbine.Shell.WriteLine(k .. " " .. v) end
-- Turbine.Shell.WriteLine(verinfo.version);
  if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
	player = Turbine.Gameplay.LocalPlayer.GetInstance();
  else
	player = Turbine.Gameplay.LocalPlayer();
  end
  return player;
end

function FilterBagWindow:SetFadeSpeed() --why do i need to define this for Lotro.Window to work?
end

-- ItemList = Turbine.PluginData.Load(Turbine.DataScope.Character, "bagsitems");

PlayerBag = "";
load_num = 0;
settings = {}
settings = Turbine.PluginData.Load( Turbine.DataScope.Character , "filterbag");

LoadWindow = class( Turbine.UI.Lotro.Window );
function LoadWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetSize(150, 100);
	if settings.posx then self:SetPosition(settings.posx+100, settings.posy+100);
	else self:SetPosition(500, 400); end
	self:SetText( "  load" );
	self:SetZOrder(100);
	self:SetVisible( false );
local loadingWindow = self
--	self.loading = Betsiel.FilterBag.UI.Label();
	self.loading = Turbine.UI.Label();
	self.loading:SetParent(self);
	self.loading:SetSize(100, 50);
	self.loading:SetPosition(25, 35);
	self.loading:SetBackColor(Turbine.UI.Color(80/255,0,45/255));
	self.loading:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	text = string.format("\n .. LOADING .. \nbag inventory");
	self.loading:SetText(text);

	self.IsVisible = function(sender, args)
--	  if glob_loading then 
	  loadingWindow:SetPosition(settings.posx+100, settings.posy+100);
-- end
	end
end

loadwindow = LoadWindow();
loadwindow:SetVisible( false );

function LoadBags(ItemList)
  load_num = load_num + 1;
  if not ItemList then
    if load_num > 1 then Turbine.Shell.WriteLine( "failed loading " .. PlayerBag ); end
    return;
  end
	MyGetPlayer();
	local backpack = player:GetBackpack();
	local backpackSize = backpack:GetSize();
	local name = "";
  Turbine.Shell.WriteLine( "loading locations of " .. backpackSize .. " items in " .. player:GetName() .. "'s bags .." );

	for j = 1, backpackSize, 1 do
	 if ItemList[j] ~= "" and ItemList[j] ~= "ZZZ" then
	  for i = 1, backpackSize, 1 do
	   tempItem = backpack:GetItem(i);
-- Turbine.Shell.WriteLine(tempItem);
  	   if tempItem then
	    name = tempItem:GetName();
	    if name and name ~= "" and ItemList[j] == name then
	      backpack:PerformItemDrop(tempItem, j, false);
	    end
	   end
	  end
	 end
	end
  glob_loading = false;
  loadwindow:SetVisible( false );
  Turbine.Shell.WriteLine( "bags arrangement loaded" );
end

function FilterBagWindow:LoadItems(savefile)
  MyGetPlayer();
  local backpack = player:GetBackpack();
  PlayerBag = string.format( '%s_bags', player:GetName() );
  if savefile then PlayerBag = savefile; end
  load_num = 0;
  glob_loading = true;
  loadwindow:SetVisible( true );
  local ItemList = Turbine.PluginData.Load(Turbine.DataScope.Server, PlayerBag, LoadBags(ItemList));
end

function update_settings()
    if glob_settings.sortb then settings.sortb = glob_settings.sortb;
    else glob_settings.sortb = settings.sortb end
    if glob_settings.sorte then settings.sorte = glob_settings.sorte;
    else glob_settings.sorte = settings.sorte end
    if glob_settings.sort then settings.sort = glob_settings.sort;
    else glob_settings.sort = settings.sort end
    if glob_settings.trans then settings.trans = glob_settings.trans;
    else glob_settings.trans = settings.trans end
--    settings.positionX=glob_settings.positionX;
--    settings.positionY=glob_settings.positionY;
end

function save_settings()
  glob_loading = true;
    update_settings();
    glob_settings.sizex = settings.sizex;
    glob_settings.sizey = settings.sizey;
    glob_settings.posx = settings.posx;
    glob_settings.posy = settings.posy;
  Turbine.PluginData.Save(Turbine.DataScope.Character, "filterbag", glob_settings);
  glob_loading = false;
--  FilterBagWindow:SetOpacity(settings.trans);
end

function FilterBagWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );

  MyGetPlayer();
  self.backpack = player:GetBackpack();

  glob_loading = true;
  settings = Turbine.PluginData.Load( Turbine.DataScope.Character , "filterbag");
  glob_loading = false;
  if debugging then
--	for k2, v2 in pairs( getmetatable(FilterBagWindow) ) do
--	  Turbine.Shell.WriteLine( "(" .. k2 .. "): " .. tostring(v2) );
--	end
    Turbine.Shell.WriteLine( "  Window control  --:" );
    Alexey.DebugTable(FilterBagWindow);
    Turbine.Shell.WriteLine( "  Turbine.Shell  --:" );
    Alexey.DebugTable(Turbine.Shell);
    Turbine.Shell.WriteLine( "  Turbine  --:" );
    Alexey.DebugTable(Turbine);
    Turbine.Shell.WriteLine( "  Turbine.Gameplay.LocalPlayer  --:" );
    Alexey.DebugTable(Turbine.Gameplay.LocalPlayer);
    Turbine.Shell.WriteLine( "  Turbine.Gameplay.Player  --:" );
    Alexey.DebugTable(Turbine.Gameplay.Player);
    Turbine.Shell.WriteLine( "  Turbine.Gameplay.Backpack  --:" );
    Alexey.DebugTable(Turbine.Gameplay.Backpack);
  end
  local ver = "0";
  if settings and settings.sizex then
    if not settings.sortb then
	 settings.sortb = 1;
	 settings.sorte = self.backpack:GetSize();
    end
    if not settings.sort then settings.sort = 1; end
    if not settings.trans then settings.trans = 1; end
  else
    settings = {}
    settings.sizex = Turbine.PluginData.Load(Turbine.DataScope.Character , "filterbagw");
    if settings.sizex then
      settings.sizey = Turbine.PluginData.Load(Turbine.DataScope.Character , "filterbagh") or 300;
    else settings.sizex = 450; settings.sizey = 330; end
    settings.posy = Turbine.PluginData.Load(Turbine.DataScope.Character , "filterbagy");
    settings.sortb = 1;
    settings.sorte = self.backpack:GetSize();
    settings.sort = 1;
    settings.trans = 1;
    if settings.posy then
      settings.posx = Turbine.PluginData.Load(Turbine.DataScope.Character , "filterbagx") or Turbine.UI.Display.GetWidth() - self:GetWidth() - 100;
    else
	self:SetSize(settings.sizex, settings.sizey);
	settings.posy = Turbine.UI.Display.GetHeight() - self:GetHeight() - 100;
	settings.posx = Turbine.UI.Display.GetWidth() - self:GetWidth() - 150;
	ver = "1.6c";
	_plugins = Turbine.PluginManager.GetLoadedPlugins();
	for i,plug in pairs(_plugins) do
	  if plug.Name == "FilterBag" then
	    ver = plug.Version;
	  end
	end
	Turbine.Shell.WriteLine("First time usage of FilterBag " .. ver);
    end
    save_settings();
  end
  if ver ~= "0" then
    self:SaveItems(nil);
    self:SetOpacity(settings.trans);
  end

	self:SetSize(settings.sizex, settings.sizey);
--	self:SetBackColor(Turbine.UI.Color());
--	self:SetBackground("Betsiel/FilterBag/empty2.tga");
	self:SetPosition(settings.posx, settings.posy);
	self:SetText( "FilterBag" );

  local filterBag = self;

	self.searchInput = Turbine.UI.Lotro.TextBox(); --text box for search term
	self.searchInput:SetParent( self );
	self.searchInput:SetVisible( true );
	self.searchInput:SetPosition(15 , 30);
	self.searchInput:SetSize(300, 20);
	self.searchInput:SetMultiline( false );
	self.searchInput:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.searchInput:SetText("");

	-- at some point i'll group these buttons on their own control to make the layout shorter, for now this shall suffice.
	self.searchbutton = Turbine.UI.Lotro.Button(); --search button!
	self.searchbutton:SetParent( self );
	self.searchbutton:SetText( "Search" );
	self.searchbutton:SetPosition( 20, 40 );
	self.searchbutton:SetSize( 48, 20 );
	self.searchbutton.Click = function( sender, args )
		self:SetOpacity(0.8);
		filterBag:Search();
		self:SetOpacity(settings.trans);
	end

	self.sortbutton = Turbine.UI.Lotro.Button(); --sort button!
	self.sortbutton:SetParent( self );
	self.sortbutton:SetText( "Sort" );
	self.sortbutton:SetPosition( 20, 40 );
	self.sortbutton:SetSize( 35, 20 );
	self.sortbutton.Click = function( sender, args )
		self:SetOpacity(0.8);
        	self:SortItems(true);
		self:SetOpacity(settings.trans);
	end

	self.savebutton = Turbine.UI.Lotro.Button(); --save button!
	self.savebutton:SetParent( self );
	self.savebutton:SetText( "Save" );
	self.savebutton:SetPosition( 20, 40 );
	self.savebutton:SetSize( 35, 20 );
	self.savebutton.Click = function( sender, args )
		self:SetOpacity(0.8);
        	filterBag:SaveItems(nil);
		self:SetOpacity(settings.trans);
	end

  self:SetWantsKeyEvents( true );
  self.items = { };
  self:SetZOrder(80);

	self.loadbutton = Turbine.UI.Lotro.Button(); --load button!
	self.loadbutton:SetParent( self );
	self.loadbutton:SetText( "Load" );
	self.loadbutton:SetPosition( 20, 40 );
	self.loadbutton:SetSize( 36, 20 );
	self.loadbutton.Click = function( sender, args )
		self:SetOpacity(0.8);
        	self:LoadItems(nil);
		self:SetOpacity(settings.trans);
		filterBag:Refresh();
	end

	self.allbutton = Turbine.UI.Lotro.Button(); --clear search button!
	self.allbutton:SetParent( self );
	self.allbutton:SetText( "Show" );
	self.allbutton:SetPosition( 20, 40 );
	self.allbutton:SetSize( 40, 20 );
	self.allbutton.Click = function( sender, args )
        self.searchInput:SetText("")
		filterBag:Search();
	end

	self.optbutton = Turbine.UI.Button(); -- options button
	self.optbutton:SetParent( self );
	self.optbutton:SetBackground("Betsiel/FilterBag/options.jpg ");
	self.optbutton:SetSize(32,32);
--	self.optbutton:SetTop(self:GetTop() + settings.sizex - 60);
--	self.optbutton:SetLeft(self:GetLeft() + settings.sizey - 40);
	self.optbutton:SetPosition( settings.sizex - 46, settings.sizey - 44 );
	self.optbutton:SetZOrder(50);
	self.optbutton.MouseEnter = function()
		self.optbutton:SetBackground("Betsiel/FilterBag/options_hover.jpg");
	end
	self.optbutton.MouseLeave = function()
		self.optbutton:SetBackground("Betsiel/FilterBag/options.jpg");
	end
	self.optbutton.Click = function( sender, args )
		options:SetVisible( true );
	end


  self.KeyDown = function( sender, args )
    if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
	sender:SetVisible( false )
    end

    if  args.Action == Turbine.UI.Lotro.Action.ToggleBags or
	args.Action == Turbine.UI.Lotro.Action.ToggleBag5 then
      sender:SetVisible( not sender:IsVisible() );
	if sender:IsVisible() then
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, false );
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, false );
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, false );
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, false );
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack5, false );
	end
    	filterBag:Refresh();
    end
    if args.Action == Turbine.UI.Lotro.Action.ToggleBag1 or
	args.Action == Turbine.UI.Lotro.Action.ToggleBag2 or
	args.Action == Turbine.UI.Lotro.Action.ToggleBag3 or
	args.Action == Turbine.UI.Lotro.Action.ToggleBag4 then
	if sender:IsVisible() then sender:SetVisible(false); end
    end
    if not sender:IsVisible() then
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
    end
    if settings.trans ~= glob_settings.trans then
	settings.trans = glob_settings.trans;
	self:SetOpacity(settings.trans);
    end
  end

	self.Closing = function(sender, args)
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack1, true );
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack2, true );
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack3, true );
	  Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Backpack4, true );
	end

	self.PositionChanged = function(sender, args)
--	Turbine.PluginData.Save(Turbine.DataScope.Character , "filterbagx", self:GetLeft());
--	Turbine.PluginData.Save(Turbine.DataScope.Character , "filterbagy", self:GetTop());
		settings.posx = self:GetLeft();
		settings.posy = self:GetTop();
		save_settings();
		self:SetOpacity(settings.trans);
		self.optbutton:SetPosition( settings.sizex - 46, settings.sizey - 44 );
		filterBag:Refresh();
	end

	self.SizeChanged = function(sender, args)
--	Turbine.PluginData.Save(Turbine.DataScope.Character , "filterbagw", self:GetWidth());
--	Turbine.PluginData.Save(Turbine.DataScope.Character , "filterbagh", self:GetHeight());
		settings.sizex = self:GetWidth();
		settings.sizey = self:GetHeight();
		save_settings();
		self:SetOpacity(settings.trans);
		self.optbutton:SetPosition( settings.sizex - 46, settings.sizey - 44 );
		filterBag:Refresh();
	end

	local mainWindow = self;

	self.itemListBoxScrollBar = Turbine.UI.Lotro.ScrollBar();
	self.itemListBoxScrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
	self.itemListBoxScrollBar:SetParent( self );

	self.itemListBox = Turbine.UI.ListBox();
	self.itemListBox:SetParent( self );
	self.itemListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	self.itemListBox:SetVerticalScrollBar( self.itemListBoxScrollBar );
	self.itemListBox:SetAllowDrop( true );

	self.itemListBox.DragDrop = function( sender, args )
		local shortcut = args.DragDropInfo:GetShortcut();
		if ( shortcut ~= nil ) then
		  local destinationItemControl = self.itemListBox:GetItemAt( args.X, args.Y );
		  local destinationIndex = self.itemListBox:IndexOfItem( destinationItemControl );
		  self.backpack:PerformShortcutDrop( shortcut, destinationIndex, Turbine.UI.Control.IsShiftKeyDown() );
		end
		filterBag:Refresh();
	end

	self.resizeHandle = Turbine.UI.Control();
	self.resizeHandle:SetParent( self );
	self.resizeHandle:SetZOrder( 100 );
	self.resizeHandle:SetSize(22, 22);
	self.resizeHandle:SetPosition( self:GetWidth() - self.resizeHandle:GetWidth(), self:GetHeight() - self.resizeHandle:GetHeight() );
	--self.resizeHandle:SetBackColor(Turbine.UI.Color());
	self.resizeHandle:SetBackground("Betsiel/FilterBag/resizehandle6.tga");
	self.resizeHandle:SetBlendMode(4);

	self.resizeHandle.MouseDown = function( sender, args )
		sender.dragStartX = args.X;
		sender.dragStartY = args.Y;
		sender.dragging = true;
	end

    self.resizeHandle.MouseMove = function( sender, args )
	local width, height = mainWindow:GetSize();

	if ( sender.dragging ) then
	  local newwidth = width + (args.X - sender.dragStartX);
	  local newheight = height + (args.Y - sender.dragStartY);
	  if newwidth < 198 then newwidth = 198; end -- any smaller than this and it's unusably small
	  if newheight < 198 then newheight = 198; end
	  mainWindow:SetSize(newwidth, newheight);
	  sender:SetPosition( mainWindow:GetWidth() - sender:GetWidth(), mainWindow:GetHeight() - sender:GetHeight() );
	  MyGetPlayer();
	  filterBag.backpack = player:GetBackpack();
	  filterBag:PerformLayout();
	end
    end

	self.resizeHandle.MouseUp = function( sender, args )
		sender.dragging = false;
	end

	-- Initialize the container that holds the elements referencing
	-- the player's inventory.

	self.backpack.SizeChanged = function( sender, args )
		filterBag:Refresh();
	end

	self.backpack.ItemAdded = function( sender, args )
		filterBag.itemListBox:RemoveItemAt(args.Index);
		filterBag.items[args.Index]:SetItem( filterBag.backpack:GetItem( args.Index ) );
		filterBag.itemListBox:InsertItem(args.Index, self.items[args.Index]);
		filterBag:Refresh();
	end

	self.backpack.ItemRemoved = function( sender, args )
		filterBag.itemListBox:RemoveItemAt(args.Index);
		filterBag.items[args.Index]:SetItem( filterBag.backpack:GetItem( args.Index ) );
		filterBag.itemListBox:InsertItem(args.Index, self.items[args.Index]);
		filterBag:Refresh();
	end

	self.backpack.ItemMoved = function( sender, args )
		filterBag.itemListBox:RemoveItemAt(args.OldIndex);
		filterBag.items[args.OldIndex]:SetItem( filterBag.backpack:GetItem( args.OldIndex ) );
		filterBag.itemListBox:InsertItem(args.OldIndex, self.items[args.OldIndex]);
		filterBag.itemListBox:RemoveItemAt(args.NewIndex);
		filterBag.items[args.NewIndex]:SetItem( filterBag.backpack:GetItem( args.NewIndex ) );
		filterBag.itemListBox:InsertItem(args.NewIndex, self.items[args.NewIndex]);
		filterBag:Refresh();
	end

	self:Refresh();
end


function FilterBagWindow:Refresh()
  MyGetPlayer();
  self.backpack = player:GetBackpack();
	local backpackSize = self.backpack:GetSize();
--	local backpack = Turbine.Gameplay.LocalPlayer.GetBackpack();
--	local backpackSize = backpack.GetSize();
	local numitems = 0;
	local additem = true;
VerCheck();
-- if debugging then Alexey.DebugTable(self.items[1]); end
-- Alexey.DebugTable(self.itemListBox);
	for i = 1, backpackSize, 1 do
		if ( self.items[i] ) then
-- if self.backpack:GetItem(i) then echo(i .. " " .. self.backpack:GetItem(i):GetName() ); end
			if Version == "" then self.items[i]:SetParent( nil ); end
			additem = false;
		else
			additem = true;
		end
		self.items[i] = Turbine.UI.Lotro.ItemControl( self.backpack:GetItem( i ) );
		self.items[i]:SetBackground("Betsiel/FilterBag/empty2.tga");
		if additem then	self.itemListBox:AddItem(self.items[i]); end
		if self.backpack:GetItem(i) then
		  numitems = numitems + 1;
		else
		  echo(i.." is an empty slot!");
		end
	end
	backpackSize = self.backpack:GetSize();
	self:SetText("FilterBag ("..numitems.."/"..backpackSize..")");
	self:PerformLayout();
  self:SetOpacity(settings.trans);
  self.optbutton:SetPosition( settings.sizex - 62, settings.sizey - 42 );
end

function FilterBagWindow:PerformLayout()
	self:Layout( { } )
end

function FilterBagWindow:Layout( args )
	local width, height = self:GetSize();

	local itemWidth = 40;

	if ( self.items[1] ~= nil ) then
		itemWidth = self.items[1]:GetWidth()
	end

	local listWidth = width - 25;
	local listHeight = height - 60;
	local itemsPerRow = listWidth / itemWidth;
	self.optbutton:SetPosition( settings.sizex - 46, settings.sizey - 44 );
	if width > 302 then -- anything smaller than this and the searchbox gets squished too much to use, this code wouold be a lot tidier if i moved the buttons/searchbox onto their own control
	  self:SetText(string.gsub(self:GetText(), "FB", "FilterBag")); --reexpand the title
      self.searchInput:SetSize(listWidth - 195, 20);
      self.searchbutton:SetPosition(listWidth - 180, 31);
      self.allbutton:SetPosition(listWidth - 135, 31);
	  self.savebutton:SetPosition(listWidth - 99, 31);
	  self.loadbutton:SetPosition(listWidth - 66, 31);
	  self.sortbutton:SetPosition(listWidth - 32, 31);

	  self.itemListBox:SetPosition(10, 50);
	  self.itemListBox:SetSize(listWidth, listHeight);
	  self.itemListBox:SetMaxItemsPerLine(itemsPerRow);
	else -- too small! move everything after the searchbox down a row
	  self:SetText(string.gsub(self:GetText(), "FilterBag", "FB")); --shrink the title so it'll fit better at smaller sizes.
      self.searchInput:SetSize(listWidth - 25, 20);
      self.searchbutton:SetPosition(listWidth - 50, 31);
      self.allbutton:SetPosition(listWidth - 37, 51);
	  self.savebutton:SetPosition(10, 51);
	  self.loadbutton:SetPosition(listWidth - 115, 51);
	  self.sortbutton:SetPosition(listWidth - 77, 51);

	  self.itemListBox:SetPosition( 5, 70 );
	  self.itemListBox:SetSize(listWidth, listHeight -20);
	  self.itemListBox:SetMaxItemsPerLine(itemsPerRow);
	end

   	self.itemListBoxScrollBar:SetPosition( width - 17, 35 );
  	self.itemListBoxScrollBar:SetSize( 10, listHeight );

end

function FilterBagWindow:Search()
    searchString = ""
    if self.searchInput then
      searchString = string.upper(self.searchInput:GetText());
	end

	MyGetPlayer();
	local backpack = player:GetBackpack();
	local backpackSize = backpack:GetSize();

	for i = 1, backpackSize, 1 do
		tempItem = backpack:GetItem(i);
  	    if tempItem then
		  itemName = string.upper(tempItem:GetName());
		  if string.find(itemName, searchString) or (searchString == "") then
			self.items[i]:SetVisible(true);
		  else
		    self.items[i]:SetVisible(false);
		  end
		end
	end
  self:SetOpacity(settings.trans);
end

function FilterBagWindow:SortItems(gui)
  MyGetPlayer();
  local backpack = player:GetBackpack();
  local backpackSize = backpack:GetSize();
  local myerror = 0;

  if not settings and not glob_loading then
    glob_loading = true;
    settings = Turbine.PluginData.Load( Turbine.DataScope.Character , "filterbag");
    glob_loading = false;
  elseif glob_loading and not settings then
   settings.sort = 1;
   settings.sortb = 1;
   settings.sorte = backpackSize;
  end
  local itemList = FilterBagWindow:GetOrderedItemList(settings.sortb, settings.sorte);

  local ItemData = { }
  for i = settings.sortb, settings.sorte, 1 do
    ItemData = itemList[i];
    if not ItemData or not ItemData[1] then
      Turbine.Shell.WriteLine( "Empty or corrupted element in sort table at position: " .. i );
      myerror = 1;
      break;
    end
    if ItemData[2] ~= "ZZZ" and	ItemData[1] >= settings.sortb and ItemData[1] <= settings.sorte then
 echo(i .. " " .. ItemData[1]);
      tempItem = backpack:GetItem(ItemData[1]);
      if not tempItem then
        Turbine.Shell.WriteLine( "item " .. ItemData[1] .. " from sort table at position: " .. i .. "not found");
        myerror = 1;
        break;
      end
 echo(ItemData[2]);
--      if i >= settings.sortb and i <= settings.sorte then
      if ItemData[1] ~= i then
	backpack:PerformItemDrop(tempItem, i, false);
      end
    end
  end
  if myerror ~= 0 then
   Turbine.Shell.WriteLine( "Internal Error!!! Please mail the following file to rusatg@yahoo.com : " );
   Turbine.Shell.WriteLine( "Documents\\The Lord of the Rings Online\\PluginData\\{Your game ID}\\{Server Name}\\" .. 
			    player:GetName() .. "\\itemList*.plugindata" );
  end
  if gui then self:Search(); end
end

function FilterBagWindow:SaveItems(savefile)
	MyGetPlayer();
	local backpack = player:GetBackpack();
	local backpackSize = backpack:GetSize();
	local tstr = string.format(" ");
	local n = 0;
	local ItemName = "";
	local category = 0;
	local ItemsList = {}

  if not settings and not glob_loading then
    glob_loading = true;
    settings = Turbine.PluginData.Load( Turbine.DataScope.Character , "filterbag");
    glob_loading = false;
  elseif glob_loading and not settings then
   settings.sort = 1;
   settings.sortb = 1;
   settings.sorte = backpackSize;
  end

 Turbine.Shell.WriteLine( "saving locations of " .. backpackSize .. " items in " .. player:GetName() .. "'s bags ..." );
	for i = 1, backpackSize, 1 do
	  tempItem = backpack:GetItem(i);
  	  if tempItem  then
	   local ItemIcon;
	   savedItemList[i] = tempItem:GetName();
 echo( savedItemList[i] );
	   ItemName = string.upper(savedItemList[i]);
	   category = tempItem:GetCategory();
	   if not VerCheck() then
	     category = CraftCategory(ItemName, category);
	     ItemIcon = tempItem:GetIconImageId();
	   else
	     ItemIcon = tempItem:GetIconImageID();
	   end
	   ItemsList[i] = { i, savedItemList[i], category, tempItem:GetQuality(), tempItem:GetQuantity(),
		 tempItem:GetDurability(), tempItem:GetWearState(), string.format("%x", ItemIcon) };
	  else
	   savedItemList[i] = "";
	   n = n + 1;
	   tstr = string.format("%s.", tstr);
	   ItemsList[i] = { i, "", 0, 0, 0, 0, 0, 0 };
	  end
	end

  if savefile == "debug" then
	Turbine.Shell.WriteLine( "  Turbine.UI.Lotro.Window   -:" );
	Alexey.DebugTable(FilterBagWindow);
	Alexey.DebugTable(Turbine.UI.Lotro);
	Alexey.DebugTable(getmetatable(Turbine.UI.Lotro.Window));
	Turbine.Shell.WriteLine( "  Turbine.Gameplay.LocalPlayer  -:" );
	Alexey.DebugTable(player);
	Turbine.Shell.WriteLine( "  player:GetBackpack  -:" );
	Alexey.DebugTable(backpack);
	Turbine.Shell.WriteLine( "  backpack:GetItem  -:" );
	Alexey.DebugTable(tempItem or backpack:GetItem(1) or backpack:GetItem(16));
  end

  local PlayerBag = string.format( '%s_bags', player:GetName() );
-- Turbine.Shell.WriteLine( PlayerBag );
  if savefile then PlayerBag = savefile; end
	Turbine.PluginData.Save(Turbine.DataScope.Server, PlayerBag, savedItemList);
	Turbine.PluginData.Save(Turbine.DataScope.Character, "bagsitems", ItemsList);
  local itemList = FilterBagWindow:GetOrderedItemList(1, backpackSize);
	Turbine.PluginData.Save(Turbine.DataScope.Character, "backpack", itemList);
 Turbine.Shell.WriteLine( tstr .. " arrangement saved");
-- if settings.trans then self:SetOpacity(settings.trans); end
end

function CraftCategory(ItemName, category)
  local category = category;

  if string.find(ItemName, "CLOAK")  then  category = 3;
  elseif string.find(ItemName, "HAT")  then  category = 3;
  elseif string.find(ItemName, "HELM")  then  category = 3;
  elseif string.find(ItemName, "CIRCLET")  then  category = 3;
  elseif string.find(ItemName, "MASK")  then  category = 3;
  elseif string.find(ItemName, "BOOT")  then  category = 3;
  elseif string.find(ItemName, "SHOE")  then  category = 3;
  elseif string.find(ItemName, "GLOVE")  then  category = 3;
  elseif string.find(ItemName, "GAUNTLET")  then  category = 3;
  elseif string.find(ItemName, "LEGG")  then  category = 3;
  elseif string.find(ItemName, "TROUSER")  then  category = 3;
  elseif string.find(ItemName, "SHOULDER")  then  category = 3;
  elseif string.find(ItemName, "BRACES")  then  category = 3;
  elseif string.find(ItemName, "ROBE")  then  category = 3;
  elseif string.find(ItemName, "SHIRT")  then  category = 3;
  elseif string.find(ItemName, "JACKET")  then  category = 3;
  elseif string.find(ItemName, "ARMOUR")  then  category = 3;
  elseif string.find(ItemName, "BREAST")  then  category = 3;
  elseif string.find(ItemName, "COAT")  then  category = 3;
  elseif string.find(ItemName, "HAUBERK")  then  category = 3;

  elseif string.find(ItemName, " MARK")  then  category = 1;
  elseif string.find(ItemName, "MAP")  then  category = 1;
  elseif string.find(ItemName, "INSIGNIA")  then  category = 1;

  elseif string.find(ItemName, "RING")  then  category = 4;
  elseif string.find(ItemName, " BAND")  then  category = 4;
  elseif string.find(ItemName, " HOOP")  then  category = 4;
  elseif string.find(ItemName, "STUD")  then  category = 4;
  elseif string.find(ItemName, "LOCH")  then  category = 4;
  elseif string.find(ItemName, "BRACE")  then  category = 4;
  elseif string.find(ItemName, "WRIST")  then  category = 4;
  elseif string.find(ItemName, "ARMLET")  then  category = 4;
  elseif string.find(ItemName, "NECKLACE")  then  category = 4;
  elseif string.find(ItemName, "AMULET")  then  category = 4;
  elseif string.find(ItemName, "CHOKER")  then  category = 4;
  elseif string.find(ItemName, "PENDANT")  then  category = 4;
  elseif string.find(ItemName, "CHARM")  then  category = 4;
  elseif string.find(ItemName, "PHIAL")  then  category = 4;
  elseif string.find(ItemName, "LOCKET")  then  category = 4;
  elseif string.find(ItemName, "FLASK")  then  category = 4;
  elseif string.find(ItemName, "FIGUR")  then  category = 4;

  elseif string.find(ItemName, "TOOL")  then  category = 5;
  elseif string.find(ItemName, "HAMMER")  then  category = 5;
  elseif string.find(ItemName, "GLASS")  then  category = 5;
  elseif string.find(ItemName, " COOK")  then  category = 5;
  elseif string.find(ItemName, "DAGGER")  then  category = 5;
  elseif string.find(ItemName, "SWORD")  then  category = 5;
  elseif string.find(ItemName, "CLUB")  then  category = 5;
  elseif string.find(ItemName, "MACE")  then  category = 5;
  elseif string.find(ItemName, "AXE")  then  category = 5;
  elseif string.find(ItemName, "BOW")  then  category = 5;
  elseif string.find(ItemName, "SPEAR")  then  category = 5;
  elseif string.find(ItemName, "SHIELD")  then  category = 5;
  elseif string.find(ItemName, "BUCKLER")  then  category = 5;
  elseif string.find(ItemName, "SKOLD")  then  category = 5;
  elseif string.find(ItemName, "TARG")  then  category = 5;
  elseif string.find(ItemName, "THAN")  then  category = 5;
  elseif string.find(ItemName, "POLE")  then  category = 5;
  elseif string.find(ItemName, "HALBERD")  then  category = 5;

  elseif string.find(ItemName, "TOKEN")  then  category = 2;
  elseif string.find(ItemName, "SCROLL")  then  category = 2;
  elseif string.find(ItemName, "LEAVES")  then  category = 2;
  elseif string.find(ItemName, "BRANCH")  then  category = 2;
  elseif string.find(ItemName, "RUNE")  then  category = 2;
  elseif string.find(ItemName, "COIN")  then  category = 2;
  elseif string.find(ItemName, "MARK")  then  category = 2;
  elseif string.find(ItemName, "BADGE")  then  category = 2;
  elseif string.find(ItemName, "MEDALLION")  then  category = 2;
  elseif string.find(ItemName, "MATHOM")  then  category = 2;

  elseif string.find(ItemName, "DRUM")  then  category = 9;
  elseif string.find(ItemName, "HORN")  then  category = 9;
  elseif string.find(ItemName, "THEORBO")  then  category = 9;
  elseif string.find(ItemName, "LUTE")  then  category = 9;
  elseif string.find(ItemName, "HARP")  then  category = 9;
  elseif string.find(ItemName, "CLARINET")  then  category = 9;
  elseif string.find(ItemName, "FLUTE")  then  category = 9;
  elseif string.find(ItemName, "BAGPIPE")  then  category = 9;
  elseif string.find(ItemName, "BELL")  then  category = 9;

  elseif string.find(ItemName, "SALVE")  then  category = 8;
  elseif string.find(ItemName, "DRAUGHT")  then  category = 8;
  elseif string.find(ItemName, "ESSENCE")  then  category = 8;
  elseif string.find(ItemName, "EXTRACT")  then  category = 8;
  elseif string.find(ItemName, "OINTMENT")  then  category = 8;

  elseif string.find(ItemName, " ORE")  then  category = 7;
  elseif string.find(ItemName, "INGOT")  then  category = 7;
  elseif string.find(ItemName, "POLISHED")  then  category = 7;
  elseif string.find(ItemName, " HILT")  then  category = 7;
  elseif string.find(ItemName, " BLADE")  then  category = 7;
  elseif string.find(ItemName, " GUARD")  then  category = 7;
  elseif string.find(ItemName, "STONE")  then  category = 7;
  elseif string.find(ItemName, "SHARD")  then  category = 7;
  elseif string.find(ItemName, "LUMP")  then  category = 7;
  elseif string.find(ItemName, "CHUNK")  then  category = 7;

  elseif string.find(ItemName, " HIDE")  then  category = 11;
  elseif string.find(ItemName, "LEATHER")  then  category = 11;
  elseif string.find(ItemName, "WOOD")  then  category = 11;
  elseif string.find(ItemName, "TREATED")  then  category = 11;
  elseif string.find(ItemName, "RESIN")  then  category = 11;
  elseif string.find(ItemName, "FIBER")  then  category = 11;

  elseif string.find(ItemName, " CROP")  then  category = 12;
  elseif string.find(ItemName, " SEED")  then  category = 12;
  elseif string.find(ItemName, "PILE")  then  category = 12;
  elseif string.find(ItemName, "SPRIG")  then  category = 12;
  elseif string.find(ItemName, "PLANT")  then  category = 12;
  elseif string.find(ItemName, "HANDFUL")  then  category = 12;
  elseif string.find(ItemName, "BUCKET")  then  category = 12;
  elseif string.find(ItemName, "SOIL")  then  category = 12;

  elseif string.find(ItemName, "CANDLE")  then  category = 6;
  elseif string.find(ItemName, " LAMP")  then  category = 6;
  elseif string.find(ItemName, "RELIC")  then  category = 6;
  elseif string.find(ItemName, "TEXT")  then  category = 6;
  elseif string.find(ItemName, "TABLET")  then  category = 6;
  elseif string.find(ItemName, "CARVING")  then  category = 6;
  elseif string.find(ItemName, "ETCHING")  then  category = 6;
  elseif string.find(ItemName, "LETTER")  then  category = 6;
  elseif string.find(ItemName, "JOURNAL")  then  category = 6;
  elseif string.find(ItemName, "PARCHMENT")  then  category = 6;
  elseif string.find(ItemName, "PIECE")  then  category = 6;
  elseif string.find(ItemName, "VIAL")  then  category = 6;
  elseif string.find(ItemName, "SCRIPT")  then  category = 6;

  elseif string.find(ItemName, "FISH")  then  category = 10;
  elseif string.find(ItemName, "RECIPE")  then  category = 10;
  elseif string.find(ItemName, "PIE")  then  category = 10;
  elseif string.find(ItemName, "RATION")  then  category = 10;
  elseif string.find(ItemName, "TART")  then  category = 10;
  elseif string.find(ItemName, "SOUP")  then  category = 10;
  elseif string.find(ItemName, "CAKE")  then  category = 10;
  elseif string.find(ItemName, "MUFFIN")  then  category = 10;
  elseif string.find(ItemName, "FILET")  then  category = 10;
  elseif string.find(ItemName, "STEW")  then  category = 10;
  elseif string.find(ItemName, " ALE")  then  category = 10;
  elseif string.find(ItemName, "WINE")  then  category = 10;
  elseif string.find(ItemName, "BEER")  then  category = 10;
  elseif string.find(ItemName, "CIDER")  then  category = 10;
  elseif string.find(ItemName, "BREW")  then  category = 10;
  elseif string.find(ItemName, "PORTER")  then  category = 10;
  elseif string.find(ItemName, "LAGER")  then  category = 10;

  elseif string.find(ItemName, "BARLEY")  then  category = 11;
  elseif string.find(ItemName, "CUP")  then  category = 11;
  elseif string.find(ItemName, "BERRI")  then  category = 11;
  elseif string.find(ItemName, "APPLE")  then  category = 11;
  elseif string.find(ItemName, "TATER")  then  category = 11;
  elseif string.find(ItemName, "ONION")  then  category = 11;
  elseif string.find(ItemName, "DROP")  then  category = 11;
  elseif string.find(ItemName, "LEMBAS")  then  category = 11;
  elseif string.find(ItemName, "BOWL")  then  category = 11;
  else
  end

  return category;
end

function FilterBagWindow:GetOrderedItemList(sortb, sorte)
  MyGetPlayer();
  local backpack = player:GetBackpack();
  local backpackSize = backpack:GetSize();

  local itemList = { }
  local tempItemName = { }
  local ItemName;
  local category;
  local i = 0;

  update_settings();
  for i = 1, backpackSize, 1 do
      tempItem = backpack:GetItem(i);
      if tempItem then
	ItemName = string.upper(tempItem:GetName());
	category = tempItem:GetCategory();
	if not VerCheck() then
	  category = CraftCategory(ItemName, category);
	else for word in string.gmatch(ItemName, "%a+") do
	  if wearWord(word) then category = 3; break end
	end end
	tempItemName = { i, ItemName, category, tempItem:GetQuality() };
  echo( tempItemName[1] .. ' ' .. tempItemName[2] .. ' ' ..  tempItemName[3] .. ' ' ..  tempItemName[4] );
	itemList[i] = tempItemName;
      else
	tempItemName = { i, "ZZZ", 254, 254 };
	itemList[i] = tempItemName;
      end
--	echo("Found at slot "..i..": "..tempItemName[2]);
  end
--	table.sort(itemList, compareTempItems);
--	table.sort(itemList, compareTempItems3);
  table.sort(itemList, compareTempItems4);

  local itemListQ = {}
--	local itemListY = { }
  local j = 0;
  local k = 0;
--	itemListY[1] = { 1, "ZZZX", 255, i };
  for i = 1, 7, 1 do
--	  table.insert( itemListQ, i, itemListY );
    itemListQ[i] = {}
    itemListQ[i][1] = { 1, "ZZZX", 255, i };
  end
  for i = 1, backpackSize, 1 do
    if j > 0 and j < 6 and j ~= itemList[i][4] or j == 7 and itemList[i][4] ~= 0 then
      itemListQ[j][k+1] = { i, "ZZZX", 255, j };
      k = 0;
    end
    k = k + 1;
    j = itemList[i][4];
    echo( i .. " " .. j .. " " .. k .. " : " .. itemList[i][2] .. " " .. itemList[i][3] );
    if j == 254 then
      j = 6;
    end
    if j == 0 then
      j = 7;
    end
    itemListQ[j][k] = itemList[i];
--  Turbine.Shell.WriteLine( itemListQ[j][k][2] );
  end
-- if j ~= 254 then
--  tempItemName = { i, "ZZZX", 255, j };
  itemListQ[j][k+1] = { i, "ZZZX", 255, j };
-- end

  Turbine.PluginData.Save(Turbine.DataScope.Character, "itemListQ", itemListQ);

  k = 0;
  if settings.sort == 1 then
    sortg = 7;
    sorto = 1;
  else
    sortg = 1;
    echo("reversed sort");
    sorto = -1;
  end
  for i = settings.sort, sortg, sorto do
    if itemListQ[i][1][3] < 254 then
      table.sort(itemListQ[i], compareTempItems);
      table.sort(itemListQ[i], compareTempItems3);
      if settings.sort ~= 1 then table.sort(itemListQ[i], compareTempItems3); end
    end
    j = 1;
    while itemListQ[i][j][3] ~= 255 do
      k = k + 1;
      itemList[k] = itemListQ[i][j];
 echo( i .. " " .. j .. " " .. k .. " : " .. itemList[k][2] .. " " .. itemList[k][3] .. " " .. itemList[k][4] );
      j = j + 1;
    end
--	  k = k - 1;
  end
  Turbine.PluginData.Save(Turbine.DataScope.Character, "itemListS", itemList);

 local myerror = 0;
  n = 0;
 if sortb ~= 1 or sorte ~= backpackSize then
  k = sortb-1; n2 = 0; n3 = 0;
  items = {}
  items2 = {}
--  for i = 1, backpackSize, 1 do
oldcode = false;
while oldcode do -- old code
    if itemList[i][1] >= sortb and itemList[i][1] <= sorte then
      k = k + 1;
      n = n + 1;
      n2 = n2 + 1;
      if i < sortb or i > sorte then
        itemListQ[7][n] = itemList[i];
        items[n] = i;
        if itemList[k][1] < sortb or itemList[k][1] > sorte then
          itemListQ[6][n2 + n3] = itemList[k];
          items2[n2 + n3] = k + n3;
        else n3 = n3 - 1; end
      else
        itemListQ[7][n] = itemList[i];
        if n3 >= 0 then n3 = n3 + 1; end
        items[n] = 0;
        if itemList[k][1] < sortb or itemList[k][1] > sorte then
          itemListQ[6][n2 + n3] = itemList[k];
          items2[n2 + n3] = k + n3;
        else
          itemListQ[6][n2] = itemList[k];
	  n3 = n3 - 1;
	end
      end
      echo(i.. " (" ..itemList[i][1].. ") " ..itemList[i][2].. ", " ..
	   k.. " (" ..itemList[k][1].. ") " ..itemList[k][2].. ": " ..n2.. " " ..n3);
    end
  end
-- ^ old code
  n = 0;
  for i = 1, backpackSize, 1 do
    if itemList[i][1] >= sortb and itemList[i][1] <= sorte then
      k = k + 1;
      n = n + 1;
      itemListQ[7][n] = itemList[i];
      itemListQ[6][n] = itemList[k];
      if i < sortb or i > sorte then
        items[n] = i;
      else items[n] = 0; end
      if itemList[k][1] < sortb or itemList[k][1] > sorte then
        items2[n] = k;
      else items2[n] = 0; end
      echo(i.. " (" ..itemList[i][1].. ") " ..itemList[i][2].. ", " ..
	   k.. " (" ..itemList[k][1].. ") " ..itemList[k][2].. ": " .. n);
    end
  end
  if debugging then
    Turbine.PluginData.Save(Turbine.DataScope.Character, "itemListQ1", itemListQ[7]);
    Turbine.PluginData.Save(Turbine.DataScope.Character, "itemListQ2", itemListQ[6]);
    Turbine.PluginData.Save(Turbine.DataScope.Character, "itemSwap1", items);
    Turbine.PluginData.Save(Turbine.DataScope.Character, "itemSwap2", items2);
  end
--  n2 = sortb-1;
--  for k = sortb, sorte, 1 do
--    if itemList[k][1] >= sortb and itemList[k][1] <= sorte then
--      n2 = n2 + 1;
--      if n2 < k then itemList[n2] = itemList[k]; end
--      echo( n2 .. " (" .. itemList[n2][1] .. ") " .. itemList[n2][2] );
--    end
--  end
  i = sortb;
  n2 = 1;
  n3 = 1;
  while n2 <= n and n3 <= n do
--    while n2 < n and items2[n2] == 0 do n2 = n2 + 1; end
--    while n3 < n and items[n3] == 0 do n3 = n3 + 1; end
--    if (n2 == n or n3 == n) and (items2[n2] == 0 or items[n3] == 0) then
--	items2[n2] = 0; items[n3] = 0;
--    end
--    if not items2[n2] then
--	myerror = 1;
--	Turbine.Shell.WriteLine( "currupted sort table at position: " .. n2+sortb-1 );
--    if items2[n2] ~= 0 then
--	itemList[items2[n2]] = itemListQ[7][n2];
--    end
    itemList[i] = itemListQ[7][n3];
    if items[n3] ~= 0 then
      while n2 < n and items2[n2] == 0 do n2 = n2 + 1; end
      itemList[items[n3]] = itemListQ[6][n2];
      echo( i .. " (" .. itemList[i][1] .. ") " .. itemList[i][2] .. ", " ..
	    items[n3] .. " (" .. itemList[items[n3]][1] .. ") " .. itemList[items[n3]][2]);
      n2 = n2 + 1;
--      if items2[n2] ~= 0 then
--	 echo( items2[n2] .. " (" .. itemList[items2[n2]][1] .. ") " .. itemList[items2[n2]][2] .. ", " ..
--      else echo(n2.. " " ..n3.. " : " .. items[n3] .. " (" .. itemList[items[n3]][1] .. ") " .. itemList[items[n3]][2]) end
--    elseif items2[n2] ~= 0 then
--      echo( items2[i] .. " (" .. itemList[items2[n2]][1] .. ") " .. itemList[items2[n2]][2] ); end
    else echo( i .. " (" .. itemList[i][1] .. ") " .. itemList[i][2] ); end
    i = i + 1;
    n3 = n3 + 1;
  end

  Turbine.PluginData.Save(Turbine.DataScope.Character, "itemListR", itemList);
 end

  k = 0;
  itemListQ[7][1] = { 1, "ZZZX", 255, 255 };
  for i = backpackSize, 2, -1 do
    if itemListQ[7][i] then table.remove(itemListQ[7], i) end
  end
  
  if myerror == 0 and #itemList == backpackSize then
  for i = sortb, sorte, 1 do
    if k ~= 0 and itemList[i][3] ~= itemListQ[7][k][3] then
--    if settings.sort == 1 then
--	table.sort(itemListQ[7], compareTempItems);
--    else
--	table.sort(itemListQ[7], compareItemsRev);
--    end
      table.sort(itemListQ[7], compareItems);
      if debugging then for j = 1, k+1, 1 do echoTable(itemListQ[7][j]) end end -- debug sort
      for j = 1, k, 1 do
        for word in string.gmatch(itemListQ[7][j][2], "%a+") do
	 if not commonWord(word) and not wearWord(word) then
  	 for n = j+1, k, 1 do
  	  if j ~= n and string.find(itemListQ[7][n][2], word) then
  	   echo(word.. ": " ..j.. " " ..itemListQ[7][j][2].. ", " ..n.. " " ..itemListQ[7][n][2]);
  	   if math.abs(j-n) == 1 then itemListQ[6][1] = itemListQ[7][n];
	   elseif j > n then
		itemListQ[6][1] = itemListQ[7][n+1];
		itemListQ[7][n+1] = itemListQ[7][j];
		itemListQ[7][j] = itemListQ[6][1];
	   else
		itemListQ[6][1] = itemListQ[7][j+1];
		itemListQ[7][j+1] = itemListQ[7][n];
		itemListQ[7][n] = itemListQ[6][1];
  	   end
  	  end
  	 end
  	 end
        end
      end
      for j = k, 1, -1 do
	i2 = i-k+j-1;
  	itemList[i2] = itemListQ[7][j];
--	echo((i2) .. " " .. itemList[i2][2]);
  	if j ~= 1 then table.remove(itemListQ[7], j) end
	if not itemList[i2] or not itemList[i2][1] then
	  Turbine.Shell.WriteLine( "Empty or corrupted element in sort table at position: " .. i2 );
	  myerror = 10;
	end
      end
      k = 0;
    end
    if itemList[i][3] < 254 then
	k = k + 1;
--	echo(itemList[i][2]);
	itemListQ[7][k] = itemList[i];
    end
  end
  end
  if debugging then
    Turbine.PluginData.Save(Turbine.DataScope.Character, "itemListE", itemList);
  end
  if myerror ~= 0 or #itemList ~= backpackSize then
   Turbine.Shell.WriteLine( i .. ", " .. j .. ", " .. k .. " : #" .. #itemList .. " " .. myerror .. " " .. backpackSize);
   Turbine.Shell.WriteLine( "Internal Error!!! Please mail the following files to rusatg@yahoo.com : " );
   Turbine.Shell.WriteLine( "My Documents\\The Lord of the Rings Online\\PluginData\\{Your game ID}\\{Server Name}\\" .. 
			    player:GetName() .. "\\itemList*.plugindata, bagsitems.plugindata, backpack.plugindata" );
   return nil;
  end

  return itemList;
end

function compareTempItems(a, b)
-- echo(a[2] .. ", " .. b[2]);
  return a[2] < b[2];
end

function compareTempItems4(a, b)
  return a[4] < b[4];
end

function compareTempItems3(a, b)
  return a[3] < b[3];
end

function compareItemsRev(a, b)
-- echo(a[2] .. ", " .. b[2]);
  return a[2] > b[2];
end

function commonWord(word)
  if word == "OF" or word == "THE" or word == "S" or word == "A" then
    return true;
  else return false; end
end

function wearWord(word)
  if word == "CLOAK" or
     word == "HAT" or word == "HELM" or word == "CIRCLET" or word == "MASK" or
     word == "BOOTS" or word == "SHOES" or
     word == "GLOVES" or word == "GAUNTLETS" or
     word == "LEGGINGS" or word == "TROUSERS" or
     word == "SHOULDERS" or word == "BRACES" or
     word == "ROBE" or word == "SHIRT" or word == "JACKET" or word == "COAT" or word == "WAISTCOAT" or
     word == "ARMOUR" or word == "BREASTPLATE" or word == "HAUBERK"  then
    return true;
  else return false; end
end

function compareItems(a, b)
  for word in string.gmatch(a[2], "%a+") do
    if not commonWord(word) and string.find(b[2], word) then
--  echo(word .. ": " .. a[2] .. ", " .. b[2]);
  return false;
    end
  end

--  echo(": " .. a[2] .. ", " .. b[2]);
  if settings.sort == 1 then return a[2] < b[2];
  else return a[2] > b[2]; end
end

